'negative pulse detector
'
'running average to establish Avgvalue, threshold and trigger
'Trigpulse when triggerd
'Ledpulse turned on 100 ms
'Ledindic turned on 10 sec
'1 ms sampling time
'
'***************************************************************************
'
'  Pinout ATtiny13/ATtiny13V   8-PDIP/SOIC
'
' (PCINT5/RESET/ADC0/dW)   PB5 VCC
' (PCINT3/CLKI/ADC3)       PB3 PB2 (SCK/ADC1/T0/PCINT2)
' (PCINT4/ADC2)            PB4 PB1 (MISO/AIN1/OC0B/INT0/PCINT1)
'                          GND PB0 (MOSI/AIN0/OC0A/PCINT0)
'
'***************************************************************************
' PB0 output  pulse IRQ
' PB1 output  Ledpulse, hi
' PB2 output  Ledindic, hi
' PB4 output  Trigpulse
' PB3 input   ADC channel 3
'***************************************************************************

$regfile = "attiny13.dat"
$crystal = 1200000
'$crystal = 9600000
$hwstack = 8
$swstack = 8
$framesize = 4

Ipulse Alias Portb.0
Ledpulse Alias Portb.1
Ledindic Alias Portb.2
Trigpulse Alias Portb.4

Const C_value = 150 - 1                                     ' Compare Match IRQ 1 ms
' Const C_value = 189 - 1  Compare Match IRQ 10 ms, 53 x 189
' C_value = 94 for 5 ms w Presc 64
' C_value = 150 for 1 ms w Presc 8
Const Threshval = 8                                         'Threshold 12.5%

Dim Currentvalue As Word , Avgvalue As Word
Dim Trig As Word , Icnt As Word
Dim Dcnt As Byte , Alarmflag As Byte , Thresh As Byte

Portb = &B00000000
Ddrb = &B00010111

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Didr0.adc3d = 1
Start Adc

Config Timer0 = Timer , Prescale = 8
Ocr0a = C_value                                             ' value for 1.2 MHz
Tccr0a = &B00000010                                         ' ctc
Timsk0.ocie0a = 1
On Oc0a Tim0_compa
Start Timer0

'CLKPR = &B10000000 'Clock Prescaler Change Enable
'CLKPR = &B00000000 'Clock Division Factor=0, 9.6MHz
Acsr.acd = 0                                                ' switch off analog comparator

'Open "comb.4:38400,8,n,1,INVERTED" For Output As #1
Enable Interrupts

Avgvalue = 1000

Do

If Icnt > 10000 Then
  Ledindic = 0                                              'show longer                                         '
  Icnt = 0
End If

Loop

'***************************************************************************
'Tim0_compa Interrupt  1 ms
'***************************************************************************
Tim0_compa:                                                 '1 ms

  Ipulse = 1
  Incr Icnt

  Currentvalue = Getadc(3)
  Avgvalue = Avgvalue * 15                                  ' (Avgvalue*15 + Currentvalue)/16
  Avgvalue = Avgvalue + Currentvalue
  Shift Avgvalue , Right , 4                                'running average

  Thresh = Avgvalue / Threshval                             'Threshold %
  Trig = Avgvalue - Thresh
  If Currentvalue < Trig Then
    Alarmflag = 1
    Trigpulse = 1                                           'pulse detected
  Else
    Trigpulse = 0
  End If

  If Alarmflag = 1 Then                                     'sw monoflop
    Ledpulse = 1                                            ' Led on
    Ledindic = 1
    Incr Dcnt
    If Dcnt > 99 Then                                       'reset sw monoflop
       Ledpulse = 0
       Alarmflag = 0
       Dcnt = 0
    End If
  End If                                                    'if Alarmflag = 1

  Ipulse = 0

Return


End